//==================================================================
//Trubetskoy Alex,  April 2004
//==================================================================

#include <vcl.h>
#include <stack.h>
#include <vector.h>
#pragma hdrstop
#include "ppn.h"
//---------------------------------------------------------------------------

class CalcExpr {
   unsigned int iLxm;           //index of the lexema string
   stack<Lxm> stack;            //stack for calculation
   bool valid;                  //if there was no calculate exceptions

   bool isOperator(Lxm lxm) {
      return (lxm.type == "op" || lxm.op == 'f');
   }

   bool isOperand(Lxm lxm) {
      return (lxm.type == "x" || lxm.type == "n");
   }

   double executeOp(Lxm op, double x);

public:
   CalcExpr(): iLxm(0) {}

   Lxm executeExpr(vector<Lxm> lxms, double x);
};
//---------------------------------------------------------------------------

