//==================================================================
//Trubetskoy Alex,  April 2004
//==================================================================

#include <vcl.h>
#pragma hdrstop

#include "Main.h"
#include "CalcExpr.h"
#include "AboutForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::miExitClick(TObject *Sender)
{
   Close();        
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::btnPaintClick(TObject *Sender)
{
   //paint graph
   if(!editFunc->Text.Length()) {
      ShowMessage("You must introduce an expression");
      return;
   }
   Form1->paintGraph(editFunc->Text);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::btnClearClick(TObject *Sender)
{
   //delete all graphs
   Form1->clearFuncs();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::miIncClick(TObject *Sender)
{
   //increase scale
   Form1->incScale();   
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::miDecClick(TObject *Sender)
{
   //decrease scale
   Form1->decScale();   
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::miAboutClick(TObject *Sender)
{
   AboutBox->ShowModal();   
}
//---------------------------------------------------------------------------

