//==================================================================
//Trubetskoy Alex,  April 2004
//==================================================================

#include <vcl.h>
#include <vector.h>
#pragma hdrstop
//---------------------------------------------------------------------------

class GraphException {
public:
   AnsiString mess;

   GraphException(AnsiString s): mess(s) {}
};
//---------------------------------------------------------------------------

struct Lxm {
   AnsiString type;    //type of the lexema
   double num;         //value (if lexema is a number)
   char op;            //operation (if lexema ia an operation)

   AnsiString ToString() {
      if(type == "n")  return AnsiString(num);
      else
      if(type == "op") return AnsiString(op);
      else return type;
   }
};
//---------------------------------------------------------------------------

class Ppn {
   vector<Lxm> outLxms;
   AnsiString inStr;            //the input string
   int iin;                     //index of the input string
   char curc;                   //the current character
   Lxm curLxm;                  //the current lexema
   int countBr;                 //count of brackets

   Lxm getNxtLxm();
   char nxtChar();
   void P();
   void E();
   void T();
   void F();
   void M();

public:
   Ppn(AnsiString str): inStr(str), iin(1), countBr(0) {}
   
   vector<Lxm> convert();
};
//---------------------------------------------------------------------------

